// Generated by CoffeeScript 1.12.7
var getAcquisitionQuery, getActivitiesForActor, getActivitiesWithActor, getActivityQuery, getAllActivitiesQuery, getAllActorQuery, getAllArtefactsAlphabetical, getArtefactAmount, getArtefactQuery, getCatalogueConcordancePerCatalogue, getCustodianQuery, getCustodyQuery, getDedicationQuery, getDiscoveryQuery, getEntityAmount, getEpigraphicQuery, getEpirgaphicActorQuery, getGraphQuery, getGraphsWithoutHasIcon, getGroupQuery, getMiscQuery, getNonEpigraphicQuery, getPartRemovalQuery, getPlaceQuery, getProductionQuery, getSignQuery, getSignQueryForTransliterationValue, getVocabluarySecondConcept, getVocabulary, keywordReplacing, sparqlEndpointVocab, vcabularyFreeSearch;

sparqlEndpointVocab = "https://www.classicmayan.org/trip/vocabularies/query";

getEpirgaphicActorQuery = function(keyword, modalToLoad) {
  var epigraphicActorQueryNormal, epigraphicActorQueryReducedByFormOfExistence;
  if (modalToLoad === "idiom_relationshipDivineTutelary") {
    return epigraphicActorQueryReducedByFormOfExistence = 'SELECT (group_concat( distinct ?actorName;separator="; ") as ?actorNames) (group_concat( distinct ?tgObject;separator="; ") as ?tgObjects) (group_concat( distinct ?pndID;separator="; ") as ?pndIDs) (group_concat( distinct ?deathDateGreg;separator=" - ") as ?deathDates) (group_concat( distinct ?gender;separator="; ") as ?genders) (group_concat( distinct ?birthDateGreg;separator="; ") as ?birthDates) (group_concat( distinct ?formExistnce;separator="; ") as ?formsExistnce) WHERE { GRAPH ?textgridURI { ?tgObject rdf:type idiom:EpigraphicActor; rdf:type ?type; idiom:prefActorAppellation ?actorAppellation; idiom:altActorAppellation ?altActorAplleation; idiom:formOfExistence ?formExistnce. FILTER (regex (str(?formExistnce), "mythological creature", "i")  || regex (str(?formExistnce), "deity", "i") ) ?altActorAplleation idiom:actorName ?altActorName. ?actorAppellation idiom:actorName ?actorName. FILTER (regex (str(?actorName), "' + keyword + '", "i")  || regex (str(?altActorName), "' + keyword + '", "i") ) OPTIONAL { ?tgObject crm:P98i_was_born ?birthEvent. ?birthEvent dc:date ?birthDate. ?birthDate idiom:gregorianDate ?birthDateGreg. } OPTIONAL { ?tgObject crm:P100i_died_in ?deathEvent. ?deathEvent dc:date ?deathDate. ?deathDate idiom:gregorianDate ?deathDateGreg. } OPTIONAL {?tgObject schema:gender ?gender.} } } group by ?tgObject';
  } else {
    return epigraphicActorQueryNormal = 'SELECT * WHERE { SELECT  (group_concat( distinct ?actorName;separator="; ") as ?actorNames) (group_concat( distinct ?tgObject;separator="; ") as ?tgObjects) (group_concat( distinct ?pndID;separator="; ") as ?pndIDs) (group_concat( distinct ?deathDateGreg;separator=" - ") as ?deathDates) (group_concat( distinct ?gender;separator="; ") as ?genders) (group_concat( distinct ?birthDateGreg;separator="; ") as ?birthDates) WHERE { GRAPH ?textgridURI { ?tgObject rdf:type idiom:EpigraphicActor; rdf:type ?type; idiom:prefActorAppellation ?actorAppellation; OPTIONAL { ?tgObject idiom:altActorAppellation ?altActorAplleation. ?altActorAplleation idiom:actorName ?altActorName.} ?actorAppellation idiom:actorName ?actorName. FILTER (regex (str(?actorName), "' + keyword + '", "i")  || regex (str(?altActorName), "' + keyword + '", "i") ) OPTIONAL { ?tgObject crm:P98i_was_born ?birthEvent. ?birthEvent dc:date ?birthDate. ?birthDate idiom:gregorianDate ?birthDateGreg. } OPTIONAL { ?tgObject crm:P100i_died_in ?deathEvent. ?deathEvent dc:date ?deathDate. ?deathDate idiom:gregorianDate ?deathDateGreg. } OPTIONAL {?tgObject schema:gender ?gender.} } }group by ?tgObject } ORDER BY ASC(?actorName)';
  }
};

getMiscQuery = function(keyword) {
  var miscQuery;
  return miscQuery = 'SELECT ?actorName ?tgObjects ?id ?residenceName ?details ?type ?birthDateDate ?deathDateDate WHERE {{ GRAPH ?textgridURI { ?tgObjects rdf:type idiom:EpigraphicActor. ?tgObjects rdf:type ?type. ?tgObjects idiom:prefActorAppellation ?actorAppellation. ?actorAppellation idiom:actorName ?actorName. FILTER (regex (str(?actorName), "' + keyword + '", "i") ) OPTIONAL { ?tgObjects crm:P98i_was_born ?birthEvent. ?birthEvent dc:date ?birthDate. ?birthDate idiom:gregorianDate ?birthDateDate. } OPTIONAL { ?tgObjects crm:P100i_died_in ?deathEvent. ?deathEvent dc:date ?deathDate. ?deathDate idiom:gregorianDate ?deathDateDate }}} UNION { GRAPH ?epigraphicGroup { ?tgObjects rdf:type idiom:EpigraphicGroup; rdf:type ?type; idiom:prefActorAppellation ?nameRef. ?nameRef idiom:actorName ?actorName. FILTER (regex (str(?actorName), "' + keyword + '", "i") ) OPTIONAL{ ?tgObjects idiom:groupType ?details; } OPTIONAL {?tgObjects crm:P74_has_current_or_former_residence ?residenceRef; BIND(IRI(CONCAT(' + "<" + ',?residenceRef,' + ">" + ')) AS $residenceUrl) GRAPH ?residencUrl { ?residenceRef crm:P87_is_identified_by ?residenceTitleRef . ?residenceTitleRef idiom:placeName ?residenceName. ?residenceTitleRef idiom:placeNameType ?residenceTitleType . BIND((CONCAT(STR(?residenceName))) AS ?lifedata) } } BIND((CONCAT(STR(?pndID2))) AS ?id) } } UNION { GRAPH ?place { ?tgObjects rdf:type crm:E53_Place. ?placeNameRef idiom:placeName ?actorName. ?tgObjects rdf:type ?type. FILTER (regex (str(?actorName), "' + keyword + '", "i") ) ?placeNameRef idiom:placeNameType ?placeNameType. OPTIONAL {?tgObjects idiom:hasGeoreferencePoint ?geoReferencePointRef. ?geoReferencePointRef wgs84pos:long ?longitude. ?geoReferencePointRef wgs84pos:lat ?latitude. ?geoReferencePointRef wgs84pos:alt ?altitude. } OPTIONAL{?tgObjects idiom:hasArchaeologicalCoordinates ?archeologicalCoordinatesRef. ?archeologicalCoordinatesRef idiom:archaeologicalCoordinates ?archeologicalCoordinates. } OPTIONAL { ?tgObjects idiom:tgnID ?gettyID } OPTIONAL { ?tgObjects idiom:geonamesID ?geonamesID } bind ( COALESCE(?gettyID, "Getty ID: ") As ?gettyIDNorm) bind ( COALESCE(?geonamesID, "Getty ID: ") As ?geonamesIDNorm) BIND((CONCAT(STR(?longitude), " | ", STR(?latitude), " | ", STR(?latitude) )) AS ?details) BIND((CONCAT("GettyID: ", STR(?gettyID), " || GeonamesID: ", STR(?geonamesID))) AS ?id) } } UNION { GRAPH ?textgridURI { ?tgObjects rdf:type crm:E7_Activity; rdf:type ?type; idiom:activityTitle ?actorName; OPTIONAL{ ?timeSpanPoint dc:date ?dateRefBegin. ?dateRefBegin idiom:isQualifiedBy "Begin". ?dateRefBegin idiom:gregorianDate ?begin. } OPTIONAL{ ?timeSpanPoint dc:date ?dateRefEnd. ?dateRefEnd idiom:isQualifiedBy "End". ?dateRefEnd idiom:gregorianDate ?end. } bind ( COALESCE(?begin, " ? ") As ?result) bind ( COALESCE(?end, " ? ") As ?result2) BIND((CONCAT(STR(?result), " - ", STR(?result2))) AS ?details) FILTER (regex (str(?actorName), "' + keyword + '", "i") ) }}}';
};

getArtefactQuery = function(keyword) {
  var artefactQuery;
  return artefactQuery = 'SELECT (group_concat( distinct ?tgObject;separator="; ") as ?tgObjects) (group_concat( distinct ?prefTitle;separator="; ") as ?prefTitles) (group_concat( distinct ?titleDisp;separator="; ") as ?titleDisps) (group_concat( distinct ?titleType;separator="; ") as ?titleTypes) (group_concat( distinct ?addIdentifierName;separator="; ") as ?addIdentifierNames) (group_concat( distinct ?addIdentifierType;separator="; ") as ?addIdentifierTypes) (group_concat( distinct ?idiomNumber;separator="; ") as ?idiomNumbers) WHERE { GRAPH ?textgridURI { ?tgObject rdf:type idiom:Artefact . ?tgObject idiom:preferredTitle ?prefTitle. FILTER (regex (str(?prefTitle), "' + keyword + '", "i")). OPTIONAL { ?tgObject idiom:identifier ?idiomNumber . } OPTIONAL { ?addIdentifier idiom:noteId ?addIdentifierName . ?addIdentifier idiom:identifierType ?addIdentifierType . } } } group by ?tgObject';
};

getEpigraphicQuery = function(keyword) {
  var epigraphicQuery;
  return epigraphicQuery = 'SELECT ?actorName ?tgObjects ?pndID ?details ?type ?lifedata WHERE { { GRAPH ?textgridURI { ?tgObjects rdf:type idiom:EpigraphicActor; rdf:type ?type. ?tgObjects idiom:prefActorAppellation ?actorAppellation. ?actorAppellation idiom:actorName ?actorName. FILTER (regex (str(?actorName), "' + keyword + '", "i") ) OPTIONAL { ?tgObjects idiom:gndID ?details. } OPTIONAL { ?tgObjects crm:P98i_was_born ?birthEvent. ?birthEvent dc:date ?birthTimeSpan. ?birthTimeSpan idiom:gregorianDate ?birthDate. } OPTIONAL { ?tgObjects crm:P100i_died_in ?deathEvent. ?deathEvent dc:date ?deathTimeSpan. ?deathTimeSpan idiom:gregorianDate ?deathDate. } OPTIONAL {?tgObjects schema:gender ?details.} bind ( COALESCE(?birthDate, " ? ") As ?result) bind ( COALESCE(?deathDate, " ? ") As ?result2) BIND((CONCAT(STR(?result), " - ", STR(?result2))) AS ?lifedata) } } UNION { GRAPH ?epigraphicGroup { ?tgObjects rdf:type idiom:EpigraphicGroup; rdf:type ?type; idiom:prefActorAppellation ?nameRef. OPTIONAL { ?tgObjects idiom:gndID ?pndID.} ?nameRef idiom:actorName ?actorName. FILTER (regex (str(?actorName), "' + keyword + '", "i") ) OPTIONAL{ ?tgObjects idiom:groupType ?details; } ?tgObjects crm:P74_has_current_or_former_residence ?residenceRef; BIND(IRI(CONCAT(' + "<" + ',?residenceRef,' + ">" + ')) AS $residenceUrl) GRAPH ?residencUrl { ?residenceRef crm:P87_is_identified_by ?residenceTitleRef . ?residenceTitleRef idiom:placeName ?residenceName. ?residenceTitleRef idiom:placeNameType ?residenceTitleType . BIND((CONCAT(STR(?residenceName))) AS ?lifedata) } } } }';
};

getAllActorQuery = function(keyword) {
  var allActorQuery;
  return allActorQuery = 'SELECT ?actorName ?tgObjects ?pndID ?details ?type ?lifedata WHERE { { GRAPH ?textgridURI { ?tgObjects rdf:type idiom:EpigraphicActor; rdf:type ?type; idiom:prefActorAppellation ?actorAppellation. ?actorAppellation idiom:actorName ?actorName. OPTIONAL{ ?tgObjects idiom:altActorAppellation ?altActorAppellation. ?altActorAppellation idiom:actorName ?altActorName.} FILTER (regex (str(?actorName), "' + keyword + '", "i") || regex (str(?altActorName), "' + keyword + '", "i")) OPTIONAL { ?tgObjects crm:P98i_was_born ?birthEvent. ?birthEvent dc:date ?birthDate. ?birthDate idiom:gregorianDate ?birthDateDate. } OPTIONAL { ?tgObjects crm:P100i_died_in ?deathEvent. ?deathEvent dc:date ?deathDate. ?deathDate idiom:gregorianDate ?deathDateDate } bind ( COALESCE(?birthDateDate, " ? ") As ?result) bind ( COALESCE(?deathDateDate, " ? ") As ?result2) BIND((CONCAT(STR(?result), " - ", STR(?result2))) AS ?lifedata) } } UNION { GRAPH ?nonEpiActor { ?tgObjects rdf:type idiom:NonEpigraphicPerson; rdf:type ?type; schema:familyName ?lastName ; schema:givenName ?givenName ; OPTIONAL{?tgObjects schema:gender ?details;} OPTIONAL{?tgObjects schema:deathDate ?deathDateDate ;} OPTIONAL{?tgObjects schema:birthDate ?birthDateDate ;} OPTIONAL{?tgObjects idiom:gndID ?pndID; } BIND((CONCAT(STR(?lastName), " ", STR(?givenName))) AS ?actorName) BIND((CONCAT(STR(?birthDateDate), " - ", STR(?deathDateDate))) AS ?lifedata) FILTER (regex (str(?actorName), "' + keyword + '", "i") ) } } UNION { GRAPH ?epigraphicGroup { ?tgObjects rdf:type idiom:EpigraphicGroup; rdf:type ?type; idiom:prefActorAppellation ?nameRef. ?nameRef idiom:actorName ?actorName. FILTER (regex (str(?actorName), "' + keyword + '", "i") ) OPTIONAL{?tgObjects idiom:gndID ?pndID; } OPTIONAL{?tgObjects idiom:groupType ?details;} ?tgObjects crm:P74_has_current_or_former_residence ?residenceRef; BIND(IRI(CONCAT(' + "<" + ',?residenceRef,' + ">" + ')) AS $residenceUrl) GRAPH ?residencUrl { ?residenceRef crm:P87_is_identified_by ?residenceTitleRef . ?residenceTitleRef idiom:placeName ?residenceName. ?residenceTitleRef idiom:placeNameType ?residenceTitleType . BIND((CONCAT(STR(?residenceName))) AS ?lifedata) } } } UNION { GRAPH ?nonepigraphicGroup { ?tgObjects rdf:type idiom:NonEpigraphicGroup ; rdf:type ?type; schema:name ?groupName; schema:alternateName ?alternateGroupName. OPTIONAL{?tgObjects idiom:gndID ?pndID; } OPTIONAL{?tgObjects idiom:groupType ?details;} ?tgObjects crm:P74_has_current_or_former_residence ?residenceRef. BIND((CONCAT(STR(?groupName), " / ", STR(?alternateGroupName))) AS ?actorName) BIND(IRI(CONCAT(' + "<" + ',?residenceRef,' + ">" + ')) AS $residenceUrl) FILTER (regex (str(?actorName), "' + keyword + '", "i") ) GRAPH ?residencUrl { ?residenceRef crm:P87_is_identified_by ?residenceTitleRef . ?residenceTitleRef idiom:placeName ?residenceName. BIND((CONCAT(STR(?residenceName))) AS ?lifedata) } } } }';
};

getNonEpigraphicQuery = function(keyword) {
  var nonEpigraphicQuery;
  keyword = keywordReplacing(keyword);
  return nonEpigraphicQuery = 'SELECT (group_concat( distinct ?tgObject;separator="; ") as ?tgObjects) (group_concat( distinct ?actorName;separator="; ") as ?actorNames) (group_concat( distinct ?pndID;separator="; ") as ?pndIDs) (group_concat( distinct ?details;separator="; ") as ?detailss) (group_concat( distinct ?type;separator="; ") as ?types) (group_concat( distinct ?lifedata;separator="; ") as ?lifedatas) (group_concat( distinct ?membership;separator="; ") as ?memberships) WHERE { { GRAPH ?nonEpiActor { ?tgObject rdf:type idiom:NonEpigraphicPerson; rdf:type ?type ; schema:familyName ?lastName ; schema:givenName ?givenName ; OPTIONAL {?tgObject schema:birthDate ?birthDateDate } OPTIONAL {?tgObject schema:deathDate ?deathDateDate .} OPTIONAL {?tgObject idiom:gndID ?pndID. } OPTIONAL {?tgObject schema:gender ?details. } OPTIONAL{ ?tgObject crm:P107i_is_former_or_current_member_of ?membershipRef. BIND(IRI(CONCAT(' + "<" + ',?membershipRef,' + ">" + ')) AS ?membershipURI) GRAPH ?membershipURI { ?membershipRef schema:name ?membership } } BIND((CONCAT(STR(?lastName), " ", STR(?givenName))) AS ?actorName) BIND((CONCAT(STR(?birthDateDate), " - ", STR(?deathDateDate))) AS ?lifedata) FILTER (regex (str(?actorName), "' + keyword + '", "i"))                                } } UNION { GRAPH ?nonepigraphicGroup { ?tgObject rdf:type idiom:NonEpigraphicGroup ; rdf:type ?type; schema:name ?groupName. OPTIONAL { ?tgObject idiom:gndID ?pndID. } OPTIONAL { ?tgObject schema:alternateName ?alternateGroupName.} OPTIONAL{ ?tgObject idiom:groupType ?details; crm:P107i_is_former_or_current_member_of ?membershipRef. BIND(IRI(CONCAT(' + "<" + ',?membershipRef,' + ">" + ')) AS $membershipURI) GRAPH ?membershipURI { ?membershipRef schema:name ?membership } } bind ( COALESCE(?alternateGroupName, " ") As ?result) BIND((CONCAT(STR(?groupName), " / ", STR(?result))) AS ?actorName) OPTIONAL { ?tgObject crm:P74_has_current_or_former_residence ?residenceRef. BIND(IRI(CONCAT(' + "<" + ',?residenceRef,' + ">" + ')) AS ?residenceUrl) GRAPH ?residencUrl { ?residenceRef crm:P87_is_identified_by ?residenceTitleRef . ?residenceTitleRef idiom:placeName ?residenceName. BIND((CONCAT(STR(?residenceName))) AS ?lifedata) }} FILTER (regex (str(?actorName), "' + keyword + '", "i") ) } } }GROUP BY ?tgObject';
};

getPlaceQuery = function(keyword) {
  var placeQuery;
  return placeQuery = 'SELECT (group_concat( distinct ?tgObject;separator="; ") as ?tgObjects) (group_concat( distinct ?placeName;separator="; ") as ?placeNames) (group_concat( distinct ?placeNameType;separator="; ") as ?placeNameTypes) (group_concat( distinct ?latitude;separator="; ") as ?latitudes) (group_concat( distinct ?longitude;separator="; ") as ?longitudes) (group_concat( distinct ?altitude;separator="; ") as ?altitudes) (group_concat( distinct ?archeologicalCoordinates;separator="; ") as ?archeologicalCoordinatess) (group_concat( distinct ?locatedPlaceNames;separator="; ") as ?locatedPlaceName) WHERE { GRAPH ?textgridURI { ?tgObject crm:P87_is_identified_by ?placeNameRef. ?placeNameRef idiom:placeName ?placeName. OPTIONAL { ?tgObject idiom:hasGeoreferencePoint ?geoReferencePointRef. OPTIONAL { ?geoReferencePointRef wgs84pos:long ?longitude.} OPTIONAL { ?geoReferencePointRef wgs84pos:lat ?latitude.} OPTIONAL {?geoReferencePointRef wgs84pos:alt ?altitude. } } OPTIONAL { ?tgObject idiom:hasArchaeologicalCoordinates ?archeologicalCoordinatesRef. ?archeologicalCoordinatesRef idiom:archaeologicalCoordinates ?archeologicalCoordinates. } OPTIONAL { ?tgObject crm:P89_falls_within ?locatedWithinRef BIND(IRI(CONCAT(' + "<" + ',?locatedWithinRef,' + ">" + ')) AS ?locatedPlaceURI) GRAPH ?locatedPlaceURI { ?locatedWithinRef crm:P87_is_identified_by ?locatedWithinPlaeNameRef. ?locatedWithinPlaeNameRef idiom:placeName ?locatedPlaceNames. ?locatedWithinPlaeNameRef idiom:placeNameType "preferred". } } } } GROUP BY ?tgObject HAVING ((regex (str(?placeNames), "' + keyword + '", "i") ))';
};

getCustodianQuery = function(keyword) {
  var custodianQuery;
  return custodianQuery = 'SELECT (group_concat( distinct ?custodian;separator="; ") as ?custodians) (group_concat( distinct ?tgObject;separator="; ") as ?tgObjects) (group_concat( distinct ?custodyTitle;separator="; ") as ?custodyTitles) (group_concat( distinct ?custodyBeginDate;separator="; ") as ?custodyBeginDates) (group_concat( distinct ?custodyEndDate;separator="; ") as ?custodyEndDates) (group_concat( distinct ?custodyCollection;separator="; ") as ?custodyCollections) (group_concat( distinct ?groupName;separator="; ") as ?groupNames) (group_concat( distinct ?custodianType;separator="; ") as ?custodianTypes) WHERE { GRAPH ?textgridURI { ?tgObject rdf:type idiom:Custody. ?tgObject idiom:activityTitle ?custodyTitle . FILTER (regex (str(?custodyTitle), "' + keyword + '", "i") ) OPTIONAL {?tgObject idiom:collection ?custodyCollection .} OPTIONAL { ?tgObject dc:date ?custodyBeginRef . BIND(IRI(CONCAT(' + "<" + ',?custodyBeginRef,' + ">" + ')) AS ?custodyBeginURI) GRAPH ?custodyBeginURI { ?custodyBeginRef idiom:isQualifiedBy "Begin". ?custodyBeginRef idiom:gregorianDate ?custodyBeginDate. } } OPTIONAL { ?tgObject dc:date ?custodyEndRef . BIND(IRI(CONCAT(' + "<" + ',?custodyEndRef,' + ">" + ')) AS ?custodyEndURI) GRAPH ?custodyEndURI{ ?custodyEndRef idiom:isQualifiedBy "End". ?custodyEndRef idiom:gregorianDate ?custodyEndDate. } } ?tgObject idiom:custodian ?custodianRef. BIND(IRI(CONCAT(' + "<" + ',?custodianRef,' + ">" + ')) AS ?custodianURI) GRAPH ?custodianURI { ?custodianRef rdf:type ?custodianType. OPTIONAL{ ?custodianRef schema:familyName ?familyName; schema:givenName ?givenName. BIND((CONCAT(STR(?familyName), ", ", STR(?givenName))) AS ?custodian) } OPTIONAL{ ?custodianRef schema:name ?custodian; } } } }GROUP BY ?textgridURI';
};

getDiscoveryQuery = function(keyword) {
  var discoveryQuery;
  return discoveryQuery = 'SELECT ?tgObjects ?placeName ?placeNameType ?explorerFamilyName ?explorerGivenName ?title WHERE { GRAPH ?textgridURI { ?tgObjects rdf:type idiom:Discovery . ?tgObjects idiom:activityTitle ?title. FILTER (regex (str(?title), "' + keyword + '", "i")) OPTIONAL { ?tgObjects crm:P7_took_place_at ?findingPlaceRef . ?findingPlaceRef crm:P87_is_identified_by ?findingPlace . ?findingPlace idiom:placeName ?placeName . ?findingPlace idiom:placeNameType ?placeNameType . ?tgObjects idiom:explorer ?explorerRef . ?explorerRef schema:familiyName ?explorerFamilyName . ?explorerRef schema:givenName ?explorerGivenName. } } }';
};

getActivityQuery = function(keyword) {
  var activityQuery;
  return activityQuery = 'SELECT (group_concat( distinct ?tgObject;separator="; ") as ?tgObjects) (group_concat( distinct ?type;separator="; ") as ?types) (group_concat( distinct ?activityTitle;separator="; ") as ?activityTitles) (group_concat( distinct ?gregorianTimeSpan;separator="; ") as ?gregorianTimeSpans) (group_concat( distinct ?placeName;separator="; ") as ?placeNames) WHERE { GRAPH ?textgridURI { ?tgObject rdf:type crm:E7_Activity; idiom:activityTitle ?activityTitle; OPTIONAL{?tgObject idiom:activityType ?type} OPTIONAL { ?timeSpanBegin dc:date ?beginRef. OPTIONAL { ?beginRef idiom:isQualifiedBy "Begin". ?beginRef idiom:gregorianDate ?gregorianDateBegin. } } OPTIONAL { ?timeSpanBegin dc:date ?endRef. OPTIONAL { ?endRef idiom:isQualifiedBy "End". ?endRef idiom:gregorianDate ?gregorianDateEnd. } } OPTIONAL { ?tgObject crm:P7_took_place_at ?placeRef. BIND(IRI(CONCAT(' + "<" + ',?placeRef,' + ">" + ')) AS ?placeURI) GRAPH ?placeURI { ?placeRef crm:P87_is_identified_by ?placeNameRef. ?placeNameRef idiom:placeName ?placeName. ?placeNameRef idiom:placeNameType ?placeNameType. } } BIND((CONCAT(STR(?gregorianDateBegin), " - ", STR(?gregorianDateEnd))) AS ?gregorianTimeSpan) FILTER (regex (str(?activityTitle), "' + keyword + '", "i") ) } }GROUP BY ?tgObject';
};

getCustodyQuery = function(keyword) {
  var custodyQuery;
  return custodyQuery = 'SELECT (group_concat( distinct ?custodian;separator="; ") as ?custodians) (group_concat( distinct ?tgObject;separator="; ") as ?tgObjects) (group_concat( distinct ?custodyTitle;separator="; ") as ?custodyTitles) (group_concat( distinct ?custodyBeginDate;separator="; ") as ?custodyBeginDates) (group_concat( distinct ?custodyEndDate;separator="; ") as ?custodyEndDates) (group_concat( distinct ?custodyCollection;separator="; ") as ?custodyCollections) (group_concat( distinct ?groupName;separator="; ") as ?groupNames) (group_concat( distinct ?custodianType;separator="; ") as ?custodianTypes) WHERE { GRAPH ?textgridURI { ?tgObject rdf:type idiom:Custody. ?tgObject idiom:activityTitle ?custodyTitle . FILTER (regex (str(?custodyTitle), "' + keyword + '", "i") ) OPTIONAL {?tgObject idiom:collection ?custodyCollection .} OPTIONAL { ?tgObject dc:date ?custodyBeginRef . BIND(IRI(CONCAT(' + "<" + ',?custodyBeginRef,' + ">" + ')) AS ?custodyBeginURI) GRAPH ?custodyBeginURI { ?custodyBeginRef idiom:isQualifiedBy "Begin". ?custodyBeginRef idiom:gregorianDate ?custodyBeginDate. } } OPTIONAL { ?tgObject dc:date ?custodyEndRef . BIND(IRI(CONCAT(' + "<" + ',?custodyEndRef,' + ">" + ')) AS ?custodyEndURI) GRAPH ?custodyEndURI{ ?custodyEndRef idiom:isQualifiedBy "End". ?custodyEndRef idiom:gregorianDate ?custodyEndDate. } } ?tgObject idiom:custodian ?custodianRef. BIND(IRI(CONCAT(' + "<" + ',?custodianRef,' + ">" + ')) AS ?custodianURI) GRAPH ?custodianURI { ?custodianRef rdf:type ?custodianType. OPTIONAL{ ?custodianRef schema:familyName ?familyName; schema:givenName ?givenName. BIND((CONCAT(STR(?familyName), ", ", STR(?givenName))) AS ?custodian) } OPTIONAL{ ?custodianRef schema:name ?custodian; } } } }GROUP BY ?tgObject';
};

getAcquisitionQuery = function(keyword) {
  var acquisitionQuery;
  return acquisitionQuery = 'SELECT ?activityTitle ?tgObjects ?timeSpan ?from ?to WHERE { GRAPH ?textgridURI { ?tgObjects rdf:type crm:E8_Acquisition . ?tgObjects idiom:activityTitle ?activityTitle . FILTER (regex (str(?activityTitle), "' + keyword + '", "i") ) OPTIONAL { ?tgObjects crm:P22_transferred_title_to ?ownerRef . BIND(IRI(CONCAT(' + "<" + ',?ownerRef,' + ">" + ')) AS ?ownerRefURI) GRAPH ?ownerRefURI { ?ownerRef schema:familyName ?ownerFamilyName . ?ownerRef schema:givenName ?ownerGivenName . BIND((CONCAT(STR(?ownerGivenName), " ", STR(?ownerFamilyName))) AS ?to) } } OPTIONAL { ?tgObjects crm:P23_transferred_title_from ?previousOwnerRef . BIND(IRI(CONCAT(' + "<" + ',?previousOwnerRef,' + ">" + ')) AS ?previousOwnerRefURI) GRAPH ?previousOwnerRefURI { ?previousOwnerRef schema:familyName ?previousOwnerFamilyName . ?previousOwnerRef schema:givenName ?previousOwnerGivenName . } BIND((CONCAT(STR(?previousOwnerGivenName), " ", STR(?previousOwnerFamilyName))) AS ?from) } OPTIONAL { ?timeSpanBegin dc:date ?beginRef. ?beginRef idiom:gregorianDate ?gregorianDateBegin. } } }';
};

getProductionQuery = function(keyword) {
  var productionQuery;
  return productionQuery = 'SELECT  ?tgObjects ?activityTitle ?placeName ?productionBeginLC ?productionEndLC ?productionDateExactlyLC ?qualifier WHERE { GRAPH ?production { ?tgObjects rdf:type crm:E12_Production ; rdf:type ?objectType; idiom:activityTitle ?activityTitle; FILTER (regex (str(?activityTitle), "' + keyword + '", "i") ) OPTIONAL { ?tgObjects dc:date ?productionBegin. ?productionBegin idiom:isQualifiedBy "Begin". ?productionBegin idiom:isQualifiedBy ?qualifier. ?productionBegin idiom:longcount ?productionBeginLC. } OPTIONAL { ?tgObjects dc:date ?productionEnd. ?productionEnd idiom:isQualifiedBy "End". ?productionBegin idiom:isQualifiedBy ?qualifier. ?productionEnd idiom:longcount ?productionEndLC. } OPTIONAL { ?tgObjects dc:date ?productionDate. ?productionDate idiom:isQualifiedBy "Exactly". ?productionBegin idiom:isQualifiedBy ?qualifier. ?productionDate idiom:longcount ?productionDateExactlyLC. } OPTIONAL { ?tgObjects crm:P7_took_place_at ?placeRef. BIND(IRI(CONCAT(' + "<" + ',?placeRef,' + ">" + ')) AS ?placeURI) GRAPH ?placeURI { ?placeRef crm:P87_is_identified_by ?placeNameRef. ?placeNameRef idiom:placeName ?placeName. } } } }';
};

getDedicationQuery = function(keyword) {
  var query;
  return query = 'SELECT ?dedication ?title ?placeName ?placeNameType ?dateRef ?longcount { GRAPH ?tgURI { ?dedication rdf:type idiom:Dedication. ?dedication idiom:activityTitle ?title. FILTER (regex (str(?title), "' + keyword + '", "i") ) OPTIONAL{ ?dedication idiom:commissioner ?commissioner. } OPTIONAL{ ?dedication crm:P7_took_place_at ?placeRef. BIND(IRI(CONCAT(' + "<" + ',?placeRef,' + ">" + ')) AS ?placeURI) GRAPH ?placeURI { ?placeRef crm:P87_is_identified_by ?placeNameRef. ?placeNameRef idiom:placeName ?placeName. ?placeNameRef idiom:placeNameType ?placeNameType. } } OPTIONAL{ ?dedication dc:date ?dateRef. BIND(IRI(CONCAT(' + "<" + ',?dateRef,' + ">" + ')) AS ?dateURI) GRAPH ?dateUri { ?dateRef idiom:longcount ?longcount. } } } }';
};

getGroupQuery = function(keyword) {
  var groupQuery;
  return groupQuery = 'SELECT (group_concat( distinct ?tgObject;separator="; ") as ?tgObjects) (group_concat( distinct ?groupName;separator="; ") as ?groupNames) (group_concat( distinct ?nonEpigraphicGroupAlternativeName;separator="; ") as ?nonEpigraphicGroupAlternativeNames) (group_concat( distinct ?gndRef;separator="; ") as ?gndRefs) (group_concat( distinct ?groupType;separator="; ") as ?groupTypes) (group_concat( distinct ?residenceTitle;separator="; ") as ?residenceTitles) (group_concat( distinct ?residenceTitleType;separator="; ") as ?residenceTitleTypes) (group_concat( distinct ?groupRef;separator="; ") as ?groupRefs) (group_concat( distinct ?type;separator="; ") as ?types) WHERE { { GRAPH ?textgridURI { ?tgObject rdf:type idiom:NonEpigraphicGroup. ?tgObject rdf:type ?type. ?tgObject schema:name ?groupName. FILTER (regex (str(?groupName), "' + keyword + '", "i") ) OPTIONAL {?tgObject schema:alternateName ?nonEpigraphicGroupAlternativeName .} OPTIONAL {?tgObject idiom:gndID ?gndRef . } OPTIONAL {?tgObject idiom:groupType ?groupType. } OPTIONAL { ?tgObject crm:P74_has_current_or_former_residence ?residenceRef . BIND(IRI(CONCAT(' + "<" + ',?residenceRef,' + ">" + ')) AS $residenceUrl) GRAPH ?residencUrl { ?residenceRef crm:P87_is_identified_by ?residenceTitleRef . ?residenceTitleRef idiom:placeName ?residenceTitle. ?residenceTitleRef idiom:placeNameType ?residenceTitleType . } } OPTIONAL { ?tgObject crm:P107i_is_former_or_current_member_of ?groupRef . } } } UNION { GRAPH ?textgridURI { ?tgObject rdf:type idiom:EpigraphicGroup. ?tgObject rdf:type ?type. ?tgObject idiom:prefActorAppellation ?nameRef. ?nameRef idiom:actorName ?groupName. FILTER (regex (str(?groupName), "' + keyword + '", "i") ) OPTIONAL{?tgObject idiom:gndID ?gndRef .} OPTIONAL{?tgObject crm:P74_has_current_or_former_residence ?residenceRef . BIND(IRI(CONCAT(' + "<" + ',?residenceRef,' + ">" + ')) AS ?residenceUrl) GRAPH ?residencUrl { ?residenceRef crm:P87_is_identified_by ?residenceTitleRef . ?residenceTitleRef idiom:placeName ?residenceTitle. ?residenceTitleRef idiom:placeNameType ?residenceTitleType . } } OPTIONAL { ?tgObject crm:P107i_is_former_or_current_member_of ?groupRef . } } } } GROUP BY ?tgObject';
};

getAllActivitiesQuery = function(keyword) {
  var allActivitiesQuery;
  return allActivitiesQuery = 'SELECT ?tgObjects ?type ?activityTitle ?gregorianDate ?lc WHERE { {GRAPH ?textgridURI { ?tgObjects rdf:type crm:E7_Activity; rdf:type ?type; idiom:activityTitle ?activityTitle; OPTIONAL{ ?timeSpanPoint dc:date ?dateRef. ?dateRef idiom:gregorianDate ?gregorianDate. ?dateRef idiom:longcount ?lc. } FILTER (regex (str(?activityTitle), "' + keyword + '", "i") || regex (str(?lc), "' + keyword + '", "i")) } } UNION { GRAPH ?acquisition { ?tgObjects rdf:type crm:E8_Acquisition ; rdf:type ?type; idiom:activityTitle ?activityTitle; OPTIONAL{ ?timeSpanPoint dc:date ?dateRef. ?dateRef idiom:gregorianDate ?gregorianDate. ?dateRef idiom:longcount ?lc. } FILTER (regex (str(?activityTitle), "' + keyword + '", "i") || regex (str(?lc), "' + keyword + '", "i")) } } UNION { GRAPH ?custody { ?tgObjects rdf:type idiom:Custody ; rdf:type ?type; idiom:activityTitle ?activityTitle; OPTIONAL{ ?timeSpanPoint dc:date ?dateRef. ?dateRef idiom:gregorianDate ?gregorianDate. ?dateRef idiom:longcount ?lc. } FILTER (regex (str(?activityTitle), "' + keyword + '", "i") || regex (str(?lc), "' + keyword + '", "i")) } } UNION { GRAPH ?production { ?tgObjects rdf:type crm:E12_Production ; rdf:type ?type; idiom:activityTitle ?activityTitle; OPTIONAL{ ?timeSpanPoint dc:date ?dateRef. ?dateRef idiom:gregorianDate ?gregorianDate. ?dateRef idiom:longcount ?lc. }  FILTER (regex (str(?activityTitle), "' + keyword + '", "i") || regex (str(?lc), "' + keyword + '", "i")) } } UNION { GRAPH ?discovery { ?tgObjects rdf:type idiom:Discovery ; rdf:type ?type; idiom:activityTitle ?activityTitle; OPTIONAL{ ?timeSpanPoint dc:date ?dateRef. ?dateRef idiom:gregorianDate ?gregorianDate. ?dateRef idiom:longcount ?lc. }  FILTER (regex (str(?activityTitle), "' + keyword + '", "i") || regex (str(?lc), "' + keyword + '", "i")) } } UNION { GRAPH ?partRemoval { ?tgObjects rdf:type crm:E80_Part_Removal; rdf:type ?type; idiom:activityTitle ?activityTitle; OPTIONAL{ ?timeSpanPoint dc:date ?dateRef. ?dateRef idiom:gregorianDate ?gregorianDate. ?dateRef idiom:longcount ?lc. }  FILTER (regex (str(?activityTitle), "' + keyword + '", "i") || regex (str(?lc), "' + keyword + '", "i")) } } }';
};

getVocabulary = function(modalToLoad) {
  var actorRoleVocabulary, vocabulary;
  if (modalToLoad === "crm_P42_assigned") {
    vocabulary = "artefacttype";
  }
  if (modalToLoad === "idiom_orientationOfArtefact") {
    vocabulary = "artefactorientation";
  }
  if (modalToLoad === "idiom_conditionType") {
    vocabulary = "conditiontype";
  }
  if (modalToLoad === "idiom_actorNameType") {
    vocabulary = "actorappellationtype";
  }
  if (modalToLoad === "idiom_assignedMaterial") {
    vocabulary = "material";
  }
  if (modalToLoad === "idiom_P14_1_in_the_role_of" || modalToLoad === "idiom_groupType" || modalToLoad === "idiom_profession") {
    vocabulary = "grouptypeactorrole";
  }
  if (modalToLoad === "idiom_placeType") {
    vocabulary = "placetype";
  }
  if (modalToLoad === "idiom_assignedTechnique") {
    vocabulary = "technique";
  }
  if (modalToLoad === "idiom_assignedShapeType") {
    vocabulary = "artefactshapetype";
  }
  if (modalToLoad === "idiom_activityType") {
    vocabulary = "activitytype";
  }
  if (modalToLoad === "idiomcat_hasIcon") {
    vocabulary = "graphicon";
  }
  return actorRoleVocabulary = 'SELECT (group_concat( distinct ?topConceptUri;separator="; ") as ?topConceptUris) (group_concat( distinct ?topConceptName;separator="; ") as ?topConceptNames) (group_concat( distinct ?next;separator="; ") as ?nexts) WHERE { <http://idiom-projekt.de/voc/' + vocabulary + '/cscheme000001> skos:hasTopConcept ?topConceptUri. ?topConceptUri skos:prefLabel ?topConceptName. OPTIONAL {?topConceptUri skos:narrower ?next.} OPTIONAL {?topConceptUri skos:definition ?def. } FILTER(LANG(?topConceptName) = "" || LANGMATCHES(LANG(?topConceptName), "en")) }GROUP BY ?topConceptUri ORDER BY ?topConceptNames';
};

getVocabluarySecondConcept = function(uri, layerDepth) {
  var labelID, query, request;
  labelID = uri;
  console.log("BÖABLA: " + uri);
  if (labelID.match(/r?graphiconr?/)) {
    uri = uri.replace("_", "\/");
  }
  if (labelID.match(/r?artefacttype?/)) {
    uri = uri.replace("_", "\/");
  }
  if (uri.match(/^concept/)) {
    uri = 'skotch:' + uri;
    labelID = uri.replace("skotch:", "");
  } else {
    if (uri.match(/r?concept?/)) {
      console.log("TADA2: " + uri);
      uri = 'skotch2:' + uri.replace("/", "\\/");
      uri = uri.replace("_", "\\/");
    } else {
      uri = 'skotch2:' + uri;
    }
    console.log("skotch2: " + uri);
  }
  query = 'PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#> PREFIX skos: <http://www.w3.org/2004/02/skos/core#> PREFIX dct: <http://purl.org/dc/terms/> PREFIX skotch: <http://localhost:8080/SkosVocabularyEditor/UserDefinedConcepts#> PREFIX skotch2: <http://idiom-projekt.de/voc/> SELECT DISTINCT (group_concat( distinct ?conceptName;separator="; ") as ?conceptNames) (group_concat( distinct ?conceptUri;separator="; ") as ?conceptUris) (group_concat( distinct ?next;separator="; ") as ?nexts) (group_concat( distinct ?def;separator="; ") as ?defs) WHERE {' + uri + ' skos:narrower ?conceptUri. ?conceptUri skos:prefLabel ?conceptName. OPTIONAL{?conceptUri skos:narrower ?next.} OPTIONAL { ?conceptUri skos:definition ?def.} FILTER(LANG(?conceptName) = "" || LANGMATCHES(LANG(?conceptName), "en")) } GROUP BY ?conceptUri ORDER BY ?conceptNames';
  console.log("QUERY: " + query);
  request = {
    'query': query
  };
  return $.ajax({
    type: 'GET',
    url: sparqlEndpointVocab,
    cache: false,
    dataType: "json",
    data: request,
    cache: false
  }).done(function(data) {
    var conceptName, definition, expand, i, id, labelid, len, result, results, results1;
    results = data['results']['bindings'];
    if (data.results.bindings.length === 0) {
      $('label#' + labelID + ' span.topConcept').remove();
    }
    results1 = [];
    for (i = 0, len = results.length; i < len; i++) {
      result = results[i];
      id = result['conceptUris']['value'];
      conceptName = result['conceptNames']['value'];
      if (typeof result['defs'] === "undefined") {
        definition = "";
      } else {
        definition = result['defs']['value'];
      }
      expand = '<span class="glyphicon glyphicon-circle-arrow-right topConcept"></span>';
      if (!id.match(/^http:\/\/localhost/)) {
        labelid = id.replace("http://idiom-projekt.de/voc/", "");
      } else {
        labelid = id.replace("http://localhost:8080/SkosVocabularyEditor/UserDefinedConcepts#", "");
      }
      labelid = labelid.replace("/", "_");
      if (typeof result['nexts'] !== "undefined") {
        $('label#' + labelID + ' div.vocabularyResultLayer' + layerDepth).append('<div class="radio"><label title="' + definition + '" class="topConcept" id="' + labelid + '"><input type="radio" name="' + modalToLoad + '-radios" value="' + id + '">' + conceptName + ' ' + expand + '</label></div>');
      } else {
        $('label#' + labelID + ' div.vocabularyResultLayer' + layerDepth).append('<div class="radio"><label title="' + definition + '" class="topConcept" id="' + labelid + '"><input type="radio" name="' + modalToLoad + '-radios" value="' + id + '">' + conceptName + ' ' + '</label></div>');
      }
      $('span.topConcept').unbind();
      results1.push($('span.topConcept').click(function(e) {
        var vocabid;
        e.preventDefault();
        e.stopPropagation();
        vocabid = $(this).parent().attr('id');
        layerDepth = $(this).parents("label.topConcept").length;
        $(this).after('<div class="vocabularyResultLayer' + layerDepth + '"></div>');
        $(this).remove();
        return getVocabluarySecondConcept(vocabid, layerDepth);
      }));
    }
    return results1;
  });
};

$(document).on("ready click", "button.vocFreeSearch", function(e) {
  var modalToLoad, vocabulary;
  console.log("BLABLABLABLABLA");
  modalToLoad = $(this).attr('id');
  if ($(this).attr('id') === "crm_P42_assigned") {
    vocabulary = "artefacttype";
  }
  if ($(this).attr('id') === "idiom_orientationOfArtefact") {
    vocabulary = "artefactorientation";
  }
  if ($(this).attr('id') === "idiom_conditionType") {
    vocabulary = "conditiontype";
  }
  if ($(this).attr('id') === "idiom_actorNameType") {
    vocabulary = "actorappellationtype";
  }
  if ($(this).attr('id') === "crm_P126_employed") {
    vocabulary = "material";
  }
  if ($(this).attr('id') === "idiom_P14_1_in_the_role_of" || modalToLoad === "idiom_groupType" || modalToLoad === "idiom_profession") {
    vocabulary = "grouptypeactorrole";
  }
  if ($(this).attr('id') === "idiom_placeType") {
    vocabulary = "placetype";
  }
  if ($(this).attr('id') === "crm_P32_used_general_technique") {
    vocabulary = "technique";
  }
  if ($(this).attr('id') === "idiom_hasShapeType") {
    vocabulary = "artefactshapetype";
  }
  if ($(this).attr('id') === "idiom_activityType") {
    vocabulary = "activitytype";
  }
  if ($(this).attr('id') === "idiomcat_hasIcon") {
    vocabulary = "graphicon";
  }
  return vcabularyFreeSearch($("input#" + modalToLoad + "-input").val(), vocabulary, $(this).attr('id'));
});

vcabularyFreeSearch = function(keyword, vocabulary, modalToLoad) {
  var query, request;
  console.log("BUJA: " + keyword);
  query = 'PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#> PREFIX skos: <http://www.w3.org/2004/02/skos/core#> PREFIX dct: <http://purl.org/dc/terms/> SELECT DISTINCT ?before ?conceptName ?conceptUri WHERE { ?conceptUri skos:prefLabel ?conceptName. FILTER (regex (str(?conceptName), "' + keyword + '", "i") ) ?conceptUri skos:broader* ?before. ?before skos:prefLabel ?conceptName2. FILTER (regex (str(?before), "' + vocabulary + '", "i")) FILTER(LANG(?conceptName) = "" || LANGMATCHES(LANG(?conceptName), "en")) }ORDER BY ?before';
  request = {
    'query': query
  };
  return $.ajax({
    type: 'GET',
    url: sparqlEndpointVocab,
    cache: false,
    dataType: "json",
    data: request,
    async: false,
    cache: false
  }).done(function(data) {
    var expand, i, j, labelID, layerDepth, len, len1, result, results, results1, uri, uris;
    results = data['results']['bindings'];
    uris = [];
    for (i = 0, len = results.length; i < len; i++) {
      result = results[i];
      uris.push(result['before']['value']);
      console.log("RESULT URI: " + result['before']['value']);
    }
    results1 = [];
    for (j = 0, len1 = uris.length; j < len1; j++) {
      uri = uris[j];
      labelID = uri.replace("http://idiom-projekt.de/voc/", "").replace("/", "_");
      expand = '<span class="glyphicon glyphicon-circle-arrow-right topConcept"></span>';
      layerDepth = 1;
      query = 'PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#> PREFIX skos: <http://www.w3.org/2004/02/skos/core#> PREFIX dct: <http://purl.org/dc/terms/> SELECT DISTINCT (group_concat( distinct ?conceptName;separator="; ") as ?conceptNames) (group_concat( distinct ?conceptUri;separator="; ") as ?conceptUris) (group_concat( distinct ?next;separator="; ") as ?nexts) (group_concat( distinct ?def;separator="; ") as ?defs) WHERE { <' + uri + '> skos:narrower ?conceptUri. ?conceptUri skos:prefLabel ?conceptName. OPTIONAL{?conceptUri skos:narrower ?next.} OPTIONAL { ?conceptUri skos:definition ?def.} FILTER(LANG(?conceptName) = "" || LANGMATCHES(LANG(?conceptName), "en")) }GROUP BY ?conceptUri';
      request = {
        'query': query
      };
      results1.push($.ajax({
        type: 'GET',
        url: sparqlEndpointVocab,
        cache: false,
        dataType: "json",
        data: request,
        async: false,
        cache: false
      }).done(function(data) {
        var conceptUri, k, layerLength, len2;
        results = data['results']['bindings'];
        for (k = 0, len2 = results.length; k < len2; k++) {
          result = results[k];
          if (typeof result['conceptUris'] !== "undefined") {
            conceptUri = result['conceptUris']['value'];
            layerLength = $('label#' + labelID + ' div.vocabularyResultLayer' + layerDepth).length;
            if (layerLength < 1) {
              $('label#' + labelID + ' span').after('<div class="vocabularyResultLayer' + layerDepth + '"></div>');
            }
            conceptUri = conceptUri.replace("http://idiom-projekt.de/voc/", "").replace("/", "_");
            $('label#' + labelID + ' div.vocabularyResultLayer' + layerDepth).append('<div class="radio"><label title="" class="topConcept" id="' + conceptUri + '"><input type="radio" name="' + modalToLoad + '-radios" value="' + result['conceptUris']['value'] + '">' + result['conceptNames']['value'] + ' ' + expand + '</label></div>');
          }
        }
        return layerDepth++;
      }));
    }
    return results1;
  });
};

getPartRemovalQuery = function(keyword) {
  var partRemovalQuery;
  return partRemovalQuery = 'SELECT ?title ?tgObjects ?relatedActivityTitle ?date ?placeName WHERE { GRAPH ?textgridURI { ?tgObjects rdf:type crm:E80_Part_Removal . FILTER (regex (str(?title), "' + keyword + '", "i") ) ?tgObjects idiom:activityTitle ?title . OPTIONAL { ?activityRef idiom:relatedActivity ?relatedActivityRef. BIND(IRI(CONCAT(' + "<" + ',?relatedActivityRef,' + ">" + ')) AS ?relatedActivityRefURI) GRAPH ?relatedActivityRefURI { ?relatedActivityRef idiom:activityTitle ?relatedActivityTitle . } } OPTIONAL { ?tgObjects dc:date ?timeSpanRef. ?timeSpanRef idiom:gregorianDate ?date. OPTIONAL { ?tgObjects crm:P7_took_place_at ?placeRef . ?placeRef crm:P87_is_identified_by ?placeNameRef . ?placeNameRef idiom:placeName ?placeName . } } } }';
};

getSignQuery = function(keyword) {
  return 'SELECT ?cldfValue ?cllmValue ?cllrValue ?clsrValue ?clnfValue ?signNumber ?tgObjects ?transValueDF ?transValueLM ?transValueLR ?transValueSR ?transValueNF WHERE { GRAPH ?tgURI { ?tgObjects rdf:type idiomcat:Sign. ?tgObjects idiomcat:signNumber "' + keyword + '". ?tgObjects idiomcat:signNumber ?signNumber. OPTIONAL { ?tgObjects idiomcat:hasDiacriticFunction ?diacricticFunctionRef. BIND(IRI(CONCAT(' + "<" + ',?diacricticFunctionRef,' + ">" + ')) AS ?diacricticFunctionURL) GRAPH ?diacricticFunctionURL{ ?diacricticFunctionRef idiomcat:transliterationValue ?transValueDF. OPTIONAL { ?diacricticFunctionRef idiomcat:hasCLDF ?cldfRef. ?cldfRef idiomcat:resultsInLevel ?cldfValue. } } } OPTIONAL { ?tgObjects idiomcat:hasLogographicMeaning ?logographicMeaningRef. BIND(IRI(CONCAT(' + "<" + ',?logographicReadingRef,' + ">" + ')) AS ?logographicReadingURL) GRAPH ?logographicReadingURL { ?logographicMeaningRef idiomcat:transliterationValue ?transValueLM. OPTIONAL { ?logographicMeaningRef idiomcat:hasCLLM ?cllmRef. ?cllmRef idiomcat:resultsInLevel ?cllmValue. } } } OPTIONAL  { ?tgObjects idiomcat:hasLogographicReading ?logographicReadingRef. BIND(IRI(CONCAT(' + "<" + ',?logographicReadingRef,' + ">" + ')) AS ?logographicReadingURL) GRAPH ?logographicReadingURL { ?logographicReadingRef idiomcat:transliterationValue ?transValueLR. OPTIONAL { ?logographicReadingRef idiomcat:hasCLLR ?cllrRef. ?cllrRef idiomcat:resultsInLevel ?cllrValue. } } } OPTIONAL { ?tgObjects idiomcat:hasSyllabicReading ?syllabicReadingRef. BIND(IRI(CONCAT(' + "<" + ',?syllabicReadingRef,' + ">" + ')) AS ?syllabicReadingURL) GRAPH ?syllabicReadingURL { ?syllabicReadingRef idiomcat:transliterationValue ?transValueSR. OPTIONAL { ?syllabicReadingRef idiomcat:hasCLSR ?clsrRef. ?clsrRef idiomcat:resultsInLevel ?clsrValue. } } } OPTIONAL { ?tgObjects idiomcat:hasNumericFunction ?numericFunctionRef. BIND(IRI(CONCAT(' + "<" + ',?numericFunctionRef,' + ">" + ')) AS ?numericFunctionURL) GRAPH ?numericFunctionRefURL { ?numericFunctionRef idiomcat:transliterationValue ?transValueNF. OPTIONAL { ?numericFunctionRef idiomcat:hasCLNF ?clnfRef. ?clnfRef idiomcat:resultsInLevel ?clnfValue. } } } } }ORDER BY ASC(xsd:integer(?signNumber))';
};

getSignQueryForTransliterationValue = function(keyword) {
  return 'SELECT ?cldfValue ?cllmValue ?cllrValue ?clsrValue ?clnfValue ?signNumber ?tgObjects ?transValueDF ?transValueLM ?transValueLR ?transValueSR ?transValueNF WHERE { GRAPH ?tgURI { ?tgObjects rdf:type idiomcat:Sign. ?tgObjects idiomcat:signNumber ?signNumber. OPTIONAL{ ?tgObjects idiomcat:hasDiacriticFunction ?diacricticFunctionRef. BIND(IRI(CONCAT(<,?diacricticFunctionRef,>)) AS ?diacricticFunctionURL) GRAPH ?diacricticFunctionURL{ ?diacricticFunctionRef idiomcat:transliterationValue ?transValueDF. FILTER (regex (str(?transValueDF), "' + keyword + '", "i")) OPTIONAL { ?diacricticFunctionRef idiomcat:hasCLDF ?cldfRef. ?cldfRef idiomcat:resultsInLevel ?cldfValue. } } } OPTIONAL{ ?tgObjects idiomcat:hasLogographicMeaning ?logographicMeaningRef. BIND(IRI(CONCAT(<,?logographicReadingRef,>)) AS ?logographicMeaningURL) GRAPH ?logographicMeaningURL { ?logographicMeaningRef idiomcat:transliterationValue ?transValueLM. FILTER (regex (str(?transValueLM), "' + keyword + '", "i")) OPTIONAL { ?logographicMeaningRef idiomcat:hasCLLM ?cllmRef. ?cllmRef idiomcat:resultsInLevel ?cllmValue. } } } OPTIONAL{ ?tgObjects idiomcat:hasLogographicReading ?logographicReadingRef. BIND(IRI(CONCAT(<,?logographicReadingRef,>)) AS ?logographicReadingURL) GRAPH ?logographicReadingURL { ?logographicReadingRef idiomcat:transliterationValue ?transValueLR. FILTER (regex (str(?transValueLR), "' + keyword + '", "i")) OPTIONAL { ?logographicReadingRef idiomcat:hasCLLR ?cllrRef. ?cllrRef idiomcat:resultsInLevel ?cllrValue.} } } OPTIONAL{ ?tgObjects idiomcat:hasSyllabicReading ?syllabicReadingRef. BIND(IRI(CONCAT(<,?syllabicReadingRef,>)) AS ?syllabicReadingURL) GRAPH ?syllabicReadingURL { ?syllabicReadingRef idiomcat:transliterationValue ?transValueSR. FILTER (regex (str(?transValueSR), "' + keyword + '", "i")) OPTIONAL { ?syllabicReadingRef idiomcat:hasCLSR ?clsrRef. ?clsrRef idiomcat:resultsInLevel ?clsrValue.} } } OPTIONAL{ ?tgObjects idiomcat:hasNumericFunction ?numericFunctionRef. BIND(IRI(CONCAT(<,?numericFunctionRef,>)) AS ?numericFunctionURL) GRAPH ?numericFunctionRefURL { ?numericFunctionRef idiomcat:transliterationValue ?transValueNF. FILTER (regex (str(?transValueNF), "' + keyword + '", "i")) OPTIONAL { ?numericFunctionRef idiomcat:hasCLNF ?clnfRef. ?clnfRef idiomcat:resultsInLevel ?clnfValue. } } } FILTER(STRLEN(?transValueDF)>0 || STRLEN(?transValueLM)>0 || STRLEN(?transValueLR)>0 || STRLEN(?transValueSR)>0 || STRLEN(?transValueNF)>0) } }ORDER BY ASC(xsd:integer(?signNumber))';
};

getGraphQuery = function(keyword) {
  return 'SELECT (group_concat( distinct ?tgObject;separator="; ") as ?tgObjects) (group_concat( distinct ?graphNumber;separator="; ") as ?graphNumbers) (group_concat( distinct ?nickName;separator="; ") as ?nickNames) (group_concat( distinct ?catalogueData;separator="; ") as ?catalogueDatas) WHERE { GRAPH ?tgURI { ?tgObject rdf:type idiomcat:Graph. FILTER (regex (str(?graphNumber), "' + keyword + '", "i") ) OPTIONAL { ?tgObject idiomcat:graphNumber ?graphNumber.} OPTIONAL { ?tgObject idiomcat:hasNickname ?nickNameRef. ?nickNameRef idiomcat:nickname ?nickName. } OPTIONAL { ?tgObject idiomcat:hasCatalogueEntry ?catalogueEntryRef. ?catalogueEntryRef idiomcat:titleOfCatalogue ?catalogueTitle. ?catalogueEntryRef idiomcat:catalogueNumber ?catalogueNumber. BIND((CONCAT(STR(?catalogueTitle), " : ", STR(?catalogueNumber) )) AS ?catalogueData) } OPTIONAL { ?tgObject idiomcat:sharesDiagnosticElementsWith ?diagnosticElementsWithRef. GRAPH ?diagnosticElementsWithUrl{ ?diagnosticElementsWithRef idiomcat:graphNumber ?graphNumber. } } } } GROUP BY ?tgObject ORDER BY ASC(xsd:integer(?graphNumber))';
};

getActivitiesWithActor = function() {
  console.log("ACTIVITIES");
  return 'SELECT (group_concat( distinct ?description;separator=" || ") as ?monument) (group_concat( distinct ?actorRef;separator="; ") as ?actorRefs) (group_concat( distinct ?agentName;separator="; ") as ?agentNames) (group_concat( distinct ?actorRefForRelatedActivity;separator="; ") as ?actorRefForRelatedActivitys) (group_concat( distinct ?gregDate;separator="; ") as ?gregDates) (group_concat( distinct ?tgUri;separator="; ") as ?tgUris) (group_concat( distinct ?placeRef;separator="; ") as ?placeRefs) (group_concat( distinct ?longcount;separator="; ") as ?longcounts) (group_concat( distinct ?activtiyTitle;separator="; ") as ?activtiyTitles) (group_concat( distinct ?actorName;separator="; ") as ?actorNames) (group_concat( distinct ?placeName;separator="; ") as ?placeNames) (group_concat( distinct ?relatedActivityTitle;separator="; ") as ?relatedActivityTitles) (group_concat( distinct ?sourceData;separator=" || ") as ?sourceDatas) (group_concat( distinct ?longcountOfBirth;separator=" || ") as ?longcountOfBirths) (group_concat( distinct ?longcountOfDeath;separator=" || ") as ?longcountOfDeaths) WHERE { GRAPH ?tgUri { ?activtiy rdf:type crm:E7_Activity. ?activtiy idiom:activityTitle ?activtiyTitle. OPTIONAL {?activity dc:description ?description.} OPTIONAL { ?activtiy dc:date ?dateRef. BIND(IRI(CONCAT(' + "<" + ',?dateRef,' + ">" + ')) AS ?dateRefURL) GRAPH ?dateRefURL { ?dateRef idiom:longcount ?longcount. ?dateRef idiom:gregorianDate ?gregDate. ?dateRef idiom:calendarEra ?calendarEra. } } OPTIONAL { ?activtiy idiom:performedBy ?actorRef. BIND(IRI(CONCAT(' + "<" + ',?actorRef,' + ">" + ')) AS ?actorURL) GRAPH ?actorURL { ?actorRef idiom:hasActor ?actorRefUri2. BIND(IRI(CONCAT(' + "<" + ',?actorRefUri2,' + ">" + ')) AS ?actorRefUri2URL) GRAPH ?actorRefUri2URL { ?actorRefUri2 idiom:prefActorAppellation ?actorNameRef. GRAPH ?actorNameRefUri { ?actorNameRef idiom:actorName ?actorName. } OPTIONAL { ?actorRefUri2 crm:P98i_was_born ?dateOfBirthRef. BIND(IRI(CONCAT(' + "<" + ',?dateOfBirthRef,' + ">" + ')) AS ?dateOfBirthURL) GRAPH ?dateOfBirthURL { ?dateOfBirthRef dc:date ?dateRefForBirth. BIND(IRI(CONCAT(' + "<" + ',?dateRefForBirth,' + ">" + ')) AS ?dateRefForBirthURL) GRAPH ?dateRefForBirthURL { ?dateRefForBirth idiom:longcount ?longcountOfBirth } } } OPTIONAL{ ?actorRefUri2 crm:P100i_died_in ?dateOfDeathRef. BIND(IRI(CONCAT(' + "<" + ',?dateOfDeathRef,' + ">" + ')) AS ?dateOfDeathURL) GRAPH ?dateOfDeathURL { ?dateOfDeathRef dc:date ?dateRefForDeath. BIND(IRI(CONCAT(' + "<" + ',?dateRefForDeath,' + ">" + ')) AS ?dateRefForDeathURL) GRAPH ?dateRefForDeathURL { ?dateRefForDeath idiom:longcount ?longcountOfDeath } } } } } } OPTIONAL { ?activity crm:P7_took_place_at ?placeRef. GRAPH ?placeRefUri { ?placeRef crm:P87_is_identified_by ?placeNameRef. GRAPH ?placeNameRefUri { ?placeNameRef idiom:placeName ?placeName. ?placeNameRef idiom:placeNameType "preferred". } } } OPTIONAL {?activity idiom:relatedActivity ?relatedActivityRef. BIND(IRI(CONCAT(' + "<" + ',?relatedActivityRef,' + ">" + ')) AS ?relatedActivityUrl) GRAPH ?relatedActivityUrl{ ?relatedActivityRef idiom:activityTitle ?relatedActivityTitle. ?relatedActivityRef idiom:performedBy ?relatedActivityPerformingActorRef. BIND(IRI(CONCAT(' + "<" + ',?relatedActivityPerformingActorRef,' + ">" + ')) AS ?relatedActivityPerformingActorUrl) GRAPH ?relatedActivityPerformingActorUrl{ ?relatedActivityPerformingActorRef idiom:hasActor ?actorRefForRelatedActivity. BIND(IRI(CONCAT(' + "<" + ',?actorRefForRelatedActivity,' + ">" + ')) AS ?actorRefForRelatedActivityURL) GRAPH ?actorRefForRelatedActivityURL { ?actorRefForRelatedActivity idiom:prefActorAppellation ?actorNameOfActorInRelatedActivityRef. BIND(IRI(CONCAT(' + "<" + ',?actorNameOfActorInRelatedActivityRef,' + ">" + ')) AS ?actorRefForRelatedActivityURL) GRAPH ?actorRefForRelatedActivityURL { ?actorNameOfActorInRelatedActivityRef idiom:actorName ?agentName. } } } } } OPTIONAL{ ?activity dct:isReferencedBy ?activitySource. BIND(IRI(CONCAT(' + "<" + ',?activitySource,' + ">" + ')) AS ?activitySourceURL) GRAPH ?activitySourceURL { ?activitySource dct:bibliographicCitation ?source. ?activitySource schema:pagination ?page. BIND((CONCAT(STR(?source), " pp. ", STR(?page) )) AS ?sourceData) } } } }group by ?tgUri ORDER BY ASC(xsd:date(?gregDates)) UCASE(str(?actorNames))';
};

getActivitiesForActor = function() {
  return 'SELECT (group_concat( distinct ?longcount;separator=" || ") as ?longcounts) (group_concat( distinct ?activtiyTitle;separator=" || ") as ?activtiyTitles) (group_concat( distinct ?actorName;separator="; ") as ?actorNames) (group_concat( distinct ?relatedActivityTitle;separator="; ") as ?relatedActivityTitles) (group_concat( distinct ?agentName;separator="; ") as ?agentNames) (group_concat( distinct ?sourceData;separator=" || ") as ?sourceDatas) (group_concat( distinct ?lc;separator=" || ") as ?lcs) (group_concat( distinct ?lcDeath;separator=" || ") as ?lcDeaths) WHERE { GRAPH ?tgUri { ?activtiy rdf:type crm:E7_Activity. ?activtiy dc:date ?dateRef. ?activtiy idiom:activityTitle ?activtiyTitle. ?activity dct:isReferencedBy ?activitySource. GRAPH ?dateRefUri { ?dateRef idiom:longcount ?longcount. } ?activtiy idiom:performedBy ?actorRef. GRAPH ?actorRefUri { ?actorRef idiom:hasActor ?actorRefUri2. GRAPH ?actorRefUri2ref { ?actorRefUri2 idiom:prefActorAppellation ?actorNameRef. GRAPH ?actorNameRefUri { ?actorNameRef idiom:actorName ?actorName. } OPTIONAL { ?actorRefForRelatedActivity crm:P98i_was_born ?birthdateRef. GRAPH ?brthdateRefUri { ?birthdateRef dc:date ?longcountRef. GRAPH ?longcountRefUri { ?longcountRef idiom:longcount ?lc. } } } OPTIONAL { ?actorRefForRelatedActivity crm:P100i_died_in ?deathdateRef. GRAPH ?deathdateRefUri { ?deathdateRef dc:date ?longcountDeathRef. GRAPH ?longcountDeathRefUri { ?longcountDeathRef idiom:longcount ?lcDeath. } } } } } OPTIONAL { ?activity idiom:relatedActivity ?relatedActivityRef. GRAPH ?relatedActivityRefUri{ ?relatedActivityRef idiom:activityTitle ?relatedActivityTitle. ?relatedActivityRef idiom:performedBy ?relatedActivityPerformingActorRef. GRAPH ?relatedActivityPerformingActorRefUri { ?relatedActivityPerformingActorRef idiom:hasActor ?actorRefForRelatedActivity. GRAPH ?actorRefForRelatedActivityUri { ?actorRefForRelatedActivity idiom:prefActorAppellation ?agentNameRef. GRAPH ?agentNameRefUri { ?actorNameRef idiom:actorName ?agentName. } } } }} GRAPH ?activitySourceRefUri { ?activitySource dct:bibliographicCitation ?source. ?activitySource schema:pagination ?page. BIND((CONCAT(STR(?source), " pp. ", STR(?page) )) AS ?sourceData) } } }Group by ?actorName';
};

getEntityAmount = function() {
  return 'SELECT (count(distinct ?tgURI) as ?count) (group_concat( distinct ?type;separator="; ") as ?gettypes) WHERE { GRAPH ?tgURI { ?s rdf:type ?type. } FILTER ( regex (str(?type), "http://erlangen-crm.org/current/E", "i") || regex (str(?type), "http://idiom-projekt.de/schema/Custody", "i") || regex (str(?type), "http://idiom-projekt.de/schema/NonEpigraphicGroup", "i") || regex (str(?type), "http://idiom-projekt.de/schema/NonEpigraphicPerson", "i") || regex (str(?type), "http://idiom-projekt.de/schema/EpigraphicGroup", "i") || regex (str(?type), "http://idiom-projekt.de/schema/Discovery", "i") || regex (str(?type), "http://idiom-projekt.de/schema/EpigraphicActor", "i") || regex (str(?type), "http://idiom-projekt.de/schema/Artefact", "i") || regex (str(?type), "http://idiom-projekt.de/schema/Dedication", "i") || regex (str(?type), "http://idiom-projekt.de/catalogue/sign", "i") || regex (str(?type), "http://idiom-projekt.de/catalogue/graph", "i")) } group by ?type';
};

getAllArtefactsAlphabetical = function(keyword, offset) {
  return 'SELECT (group_concat( distinct ?tgObject;separator="; ") as ?tgObjects) (group_concat( distinct ?prefTitle;separator="; ") as ?prefTitles) (group_concat( distinct ?titleDisp;separator="; ") as ?titleDisps) (group_concat( distinct ?titleType;separator="; ") as ?titleTypes) (group_concat( distinct ?addIdentifierName;separator="; ") as ?addIdentifierNames) (group_concat( distinct ?addIdentifierType;separator="; ") as ?addIdentifierTypes) (group_concat( distinct ?idiomNumber;separator="; ") as ?idiomNumbers) WHERE { GRAPH ?textgridURI { ?tgObject rdf:type idiom:Artefact . ?tgObject idiom:preferredTitle ?prefTitle. FILTER (regex (str(?prefTitle), "' + keyword + '", "i")). OPTIONAL { ?tgObject idiom:identifier ?idiomNumber . } OPTIONAL { ?addIdentifier idiom:noteId ?addIdentifierName . ?addIdentifier idiom:identifierType ?addIdentifierType . } } } group by ?tgObject order by ASC( ?prefTitles) LIMIT 50 OFFSET ' + offset;
};

getArtefactAmount = function(keyword) {
  return 'SELECT (count(distinct ?tgObject) as ?count) WHERE { GRAPH ?textgridURI { ?tgObject rdf:type idiom:Artefact . ?tgObject idiom:preferredTitle ?prefTitle. FILTER (regex (str(?prefTitle), "' + keyword + '", "i")). } } ';
};

getGraphsWithoutHasIcon = function() {
  return 'SELECT DISTINCT ?graph ?graphNumber WHERE { GRAPH ?graph { ?textUri rdf:type idiomcat:Graph. ?textUri idiomcat:graphNumber ?graphNumber. FILTER NOT EXISTS{?textUri idiomcat:hasIcon ?graphWithoutIcon} } }';
};

getCatalogueConcordancePerCatalogue = function(catalogue) {
  return 'SELECT (group_concat( distinct ?catalogueTitle;separator="; ") as ?catalogueTitles) (group_concat( distinct ?catalogueNumber;separator="; ") as ?catalogueNumbers) (group_concat( distinct ?variant;separator="; ") as ?variants) (group_concat( distinct ?graphNumber;separator="; ") as ?IDIOMCatalogue) (group_concat( distinct ?hatschi;separator="; ") as ?hatschis) (group_concat( distinct ?imageInCatalogue;separator="; ") as ?imageInCatalogues) (group_concat( distinct ?imageInIDIOMCatalogue;separator="; ") as ?imageInIDIOMCatalogues) WHERE { GRAPH ?graph { ?textUri rdf:type idiomcat:Graph. ?textUri idiomcat:hasCatalogueEntry ?catalogueEntryRef. ?textUri idiomcat:graphNumber ?graphNumber. ?textUri idiomcat:variationType ?variant. ?textUri idiomcat:hasDigitalImage ?imageInIDIOMCatalogue. BIND(IRI(CONCAT(' + "<" + ',?catalogueEntryRef,' + ">" + ')) AS ?catalogueEntryURL) GRAPH ?catalogueEntryURL { ?catalogueEntryRef idiomcat:titleOfCatalogue ?catalogueTitle. ?catalogueEntryRef idiomcat:catalogueNumber ?catalogueNumber. ?catalogueEntryRef idiomcat:imageInCatalogue ?imageInCatalogue. FILTER (regex (str(?catalogueTitle), "' + catalogue.replace("(", "\\\\(").replace(")", "\\\\)") + '", "i")) } BIND(str(REPLACE(?catalogueNumber, "\\\\D+", "")) AS ?hatschi) } } GROUP BY ?catalogueTitle ?catalogueNumber ORDER BY ASC(xsd:integer(?hatschis))';
};

keywordReplacing = function(keyword) {
  keyword = keyword.replace(/a/g, "[áāăąa]");
  keyword = keyword.replace(/A/g, "[ĀĂĄA]");
  keyword = keyword.replace(/c/g, "[ćĉċčc]");
  keyword = keyword.replace(/C/g, "[ĆĈĊČC]");
  keyword = keyword.replace(/d/g, "[ďđd]");
  keyword = keyword.replace(/D/g, "[ĎĐD]");
  keyword = keyword.replace(/e/g, "[éēĕėęěe]");
  keyword = keyword.replace(/E/g, "[ĒĔĖĘĚE]");
  keyword = keyword.replace(/g/g, "[ĝğġģg]");
  keyword = keyword.replace(/G/g, "[ĜĞĠĢG]");
  keyword = keyword.replace(/h/g, "[ĥħh]");
  keyword = keyword.replace(/H/g, "[ĤĦH]");
  keyword = keyword.replace(/i/g, "[íĩīĭįıi]");
  keyword = keyword.replace(/I/g, "[ĨĪĬĮİI]");
  keyword = keyword.replace(/j/g, "[ĳĵj]");
  keyword = keyword.replace(/J/g, "[ĲĴJ]");
  keyword = keyword.replace(/k/g, "[ķĸk]");
  keyword = keyword.replace(/K/g, "[ĶK]");
  keyword = keyword.replace(/l/g, "[łĺļľŀl]");
  keyword = keyword.replace(/L/g, "[ĹĻĽĿŁL]");
  keyword = keyword.replace(/n/g, "[ñńņňŉŋn]");
  keyword = keyword.replace(/N/g, "[ŃŅŇŊN]");
  keyword = keyword.replace(/o/g, "[óōŏőœo]");
  keyword = keyword.replace(/O/g, "[ŌŎŐŒO]");
  keyword = keyword.replace(/r/g, "[ŕŗřr]");
  keyword = keyword.replace(/R/g, "[ŔŖŘR]");
  keyword = keyword.replace(/s/g, "[śŝşšs]");
  keyword = keyword.replace(/S/g, "[ŚŜŞŠS]");
  keyword = keyword.replace(/t/g, "[ţťŧt]");
  keyword = keyword.replace(/T/g, "[TŤŦŢ]");
  keyword = keyword.replace(/u/g, "[úũūŭůűųu]");
  keyword = keyword.replace(/U/g, "[ŨŪŬŮŰŲU]");
  keyword = keyword.replace(/w/g, "[ŵw]");
  keyword = keyword.replace(/W/g, "[ŴW]");
  keyword = keyword.replace(/y/g, "[ŷy]");
  keyword = keyword.replace(/Y/g, "[ŶŸY]");
  keyword = keyword.replace(/z/g, "[źżžz]");
  keyword = keyword.replace(/Z/g, "[ŹŹŻŽZ]");
  keyword = keyword.replace(/'/g, "['‘’]");
  return keyword = keyword.replace(/"/g, "[\"”«»]");
};
